#	Program:	makeRTDB_Subs.AWK
#
#	Author:         Dave Femia
#                       Integral Engineering
#                       dfemia@integral.usa1.com
#                       508.448.2894 (Pager 800.592.0933)
#
#       Date:           Rev.1           August 8, 1995
#
#       Purpose:        Create RTDB subscription create and destroy tag files
#
#START BEGIN

BEGIN{
	FS="~"
	i = 0
	while(getline < "Chars.SED"> 0 ) {
	i = i + 1

	ITEM_NO[i]		= $1
	PROCESS_REV_NO[i]	= $2
	OPER_NO[i]		= $3
	PLAN_REV_NO[i]		= $4
	STEP_NO[i]		= $5
	STEP_DESC[i]		= $6
	CLASS[i]		= $7
	SUB_SIZE[i]		= $8
	GAGE_NAME[i]		= $9
	GAGE_NO[i]		= $10
	CHANNEL[i]		= $11
	NUM_CHARS[i]		= $12
	PORT_ID[i]		= $13
	BAUD_RATE[i]		= $14
	DATABITS[i]		= $15
	STOP_BITS[i]		= $16
	PARITY[i]		= $17
	START_STRING[i]		= $18
	STOP_STRING[i]		= $19
	EOM[i]			= $20
	DEC_PL[i]		= $21
	TAPE_NO[i]		= $22
	UPPER_SPEC[i]		= $23
	LOWER_SPEC[i]		= $24
	NOMINAL_VALUE[i]	= $25
	NOMINAL_UNITS[i]	= $26
	UPPER_FLYER[i]		= $27
	LOWER_FLYER[i]		= $28
	TARGET_VALUE[i]		= $29
	NO_MEAS[i]		= $30
	PRE_UCL[i]		= $31
	PRE_LCL[i]		= $32
	SPC[i]			= $33
	DATA_COLLECT[i]		= $34
	MEAS_ID[i]		= $35
	OPER_SUFX[i]		= $36

	ACTUAL_USL[i]		= NOMINAL_VALUE[i] + UPPER_SPEC[i]
	ACTUAL_LSL[i]		= NOMINAL_VALUE[i] - LOWER_SPEC[i]

	DIFF[i]			= ( ACTUAL_USL[i] - ACTUAL_LSL[i] ) / 2.0

	if ( UPPER_FLYER[i] == "null" ) {
		ACTUAL_UP_FLY[i]        = NOMINAL_VALUE[i] + (1.5 * DIFF[i])
		}
	else
		{
		ACTUAL_UP_FLY[i]        = NOMINAL_VALUE[i] + UPPER_FLYER[i]
		}

	if ( LOWER_FLYER[i] == "null" ) {
		ACTUAL_LOW_FLY[i]       = NOMINAL_VALUE[i] - (1.5 * DIFF[i])
		}
	else
		{
		ACTUAL_LOW_FLY[i]       = NOMINAL_VALUE[i] - LOWER_FLYER[i]
		} 

		
	printf("Orig:  USL: %s NOM: %s LSL: %s \n", UPPER_SPEC[i], NOMINAL_VALUE[i], LOWER_SPEC[i] )	
	printf("USL: %s NOM: %s LSL: %s UFL: %s LFL:%s \n",ACTUAL_USL[i],NOMINAL_VALUE[i],ACTUAL_LSL[i],ACTUAL_UP_FLY[i],ACTUAL_LOW_FLY[i] )

#	Read tag list and create a file for all steps.

	if( i == 1 ) 
	{

		printf("CASE:  i=1 \n")

		tags_on		=	sprintf("%s/%s_Tags_On.RTDB", RTdir, NAME )
		printf("     tags_on: %s/%s_Tags_On.RTDB \n", RTdir, NAME )
		tags_off	=	sprintf("%s/%s_Tags_Off.RTDB", RTdir, NAME )

		remove		=	sprintf("rm %s", tags_on )
		system(remove)
		remove		=	sprintf("rm %s", tags_off )
		system(remove)
		print("\n") 	> 	tags_on
		chmod		=	sprintf("chmod 666 %s", tags_on )
		system(chmod)
		printf("     tags_on: created. \n")

		print("\n") 	> 	tags_off
		chmod		=	sprintf("chmod 666 %s", tags_off )
		system(chmod)

		subs_on		=	sprintf("%s/%s_Subs_On.RTDB", RTdir, NAME )
		subs_off	=	sprintf("%s/%s_Subs_Off.RTDB", RTdir, NAME )

		remove		=	sprintf("rm %s", subs_on )
		system(remove)
		remove		=	sprintf("rm %s", subs_off )
		system(remove)
		print("\n") 	> 	subs_on
		chmod		=	sprintf("chmod 666 %s", subs_on )
		system(chmod)
		print("\n") 	> 	subs_off
		chmod		=	sprintf("chmod 666 %s", subs_off )
		system(chmod)
	}

	printf("Tracing to trace1 \n")
	trace = sprintf("CWtrace -n trace1 Creating %s RTDBsrv tags \n", i )
	printf("After tracing to trace1 \n")
	system(trace)

	print("i = " i )

	nom_val		= sprintf("create tag name=nominal.%s value=%s \n", STEP_NO[i], NOMINAL_VALUE[i] ) 
	des_nom_val	= sprintf("destroy tag name=nominal.%s \n", STEP_NO[i] )

	desc		= sprintf("create tag name=desc.%s \"value=%s\" \n", STEP_NO[i], STEP_DESC[i] )
	des_desc	= sprintf("destroy tag name=desc.%s \n", STEP_NO[i] )

	nom_units	= sprintf("create tag name=units.%s value=%s \n", STEP_NO[i], NOMINAL_UNITS[i] )
	des_nom_units	= sprintf("destroy tag name=units.%s \n", STEP_NO[i] )

	target		= sprintf("create tag name=target.%s value=%s \n", STEP_NO[i], TARGET_VALUE[i] )
	des_target	= sprintf("destroy tag name=target.%s \n", STEP_NO[i] )

	upper_spec	= sprintf("create tag name=us.%s value=%s \n", STEP_NO[i], ACTUAL_USL[i] )
	des_upper_spec	= sprintf("destroy tag name=us.%s \n", STEP_NO[i] )

	lower_spec	= sprintf("create tag name=ls.%s value=%s \n", STEP_NO[i], ACTUAL_LSL[i] )
	des_lower_spec	= sprintf("destroy tag name=ls.%s \n", STEP_NO[i] )

	upper_flyer	= sprintf("create tag name=uf.%s value=%s \n", STEP_NO[i], ACTUAL_UP_FLY[i] )
	des_upper_flyer	= sprintf("destroy tag name=uf.%s \n", STEP_NO[i] )

	lower_flyer	= sprintf("create tag name=lf.%s value=%s \n", STEP_NO[i], ACTUAL_LOW_FLY[i] )
	des_lower_flyer	= sprintf("destroy tag name=lf.%s \n", STEP_NO[i] )

	raw_data	= sprintf("create tag name=raw_data.%s \n", STEP_NO[i] )
	des_raw_data	= sprintf("destroy tag name=raw_data.%s \n", STEP_NO[i] )
	sub_raw_new	= sprintf("sub tag name=raw_data.%s mbx=RTDBsrv \"outmap=updt name=new_data.%s value=UPDATE\" \n",STEP_NO[i],STEP_NO[i] )

	post_data = sprintf("create tag name=post_data.%s \"com=(%%%%sunits.%s == \\\"micr\\\")?(%%%%fraw_data.%s/1000.0) : %%%%fraw_data.%s \" \n", STEP_NO[i], STEP_NO[i], STEP_NO[i], STEP_NO[i] )
	des_post_data = sprintf("destroy tag name=post_data.%s \n", STEP_NO[i] )
	print(post_data)

	data		= sprintf("create tag name=data.%s \"com=(%%%%starget.%s != \\\"null\\\") ? (%%%%fnominal.%s + %%%%fpost_data.%s) : %%%%fpost_data.%s \" \n", STEP_NO[i], STEP_NO[i], STEP_NO[i], STEP_NO[i], STEP_NO[i] )
	des_data	= sprintf("destroy tag name=data.%s \n", STEP_NO[i] )
	sub_data_char	= sprintf("sub tag name=raw_data.%s mbx=WINsrv \"outmap=mod field winCharMach fldChar \\\"value=%s\\\" \" \n", STEP_NO[i], STEP_DESC[i] )
	sub_data_nom	= sprintf("sub tag name=raw_data.%s mbx=WINsrv \"outmap=mod field winCharMach fldSpec \\\"value=%s\\\" \" \n", STEP_NO[i], NOMINAL_VALUE[i] )

	new_data	= sprintf("create tag name=new_data.%s \n", STEP_NO[i] )
	des_new_data	= sprintf("destroy tag name=new_data.%s \n", STEP_NO[i] )

	sub_data_val	= sprintf("sub tag name=new_data.%s mbx=WINsrv \"outmap=mod field winCharMach fldValue \\\"value=%%%%s\\\" \" com=data.%s \n", STEP_NO[i], STEP_NO[i] )
	sub_data_indv_b	= sprintf("sub tag name=new_data.%s mbx=WINsrv \"outmap=mod button winDataCollect btnValue_%s label=%%%%s \" com=data.%s\n", STEP_NO[i], STEP_NO[i], STEP_NO[i] )
	sub_data_indv_f	= sprintf("sub tag name=new_data.%s mbx=WINsrv \"outmap=mod field winDataCollect fldValue_%s value=%%%%s \" com=raw_data.%s\n", STEP_NO[i], STEP_NO[i], STEP_NO[i] )
	sub_data_indv_x	= sprintf("sub tag name=context.%s mbx=WINsrv \"outmap=mod box winDataCollect boxValue_%s cx=%%%%s \" \n", STEP_NO[i], STEP_NO[i], STEP_NO[i] )

	print(data)

	init		= sprintf("create tag name=init.%s value=INIT \n", STEP_NO[i] )
	des_init	= sprintf("destroy tag name=init.%s \n", STEP_NO[i] )

	S		= STEP_NO[i]
	ctx		=  sprintf("create tag name=ctx.%s \"com=(%%%%sinit.%s == \\\"INIT\\\") ? -1 : ((%%%%fdata.%s <= %%%%flf.%s) ? 2 : (((%%%%fdata.%s > %%%%flf.%s) && (%%%%fdata.%s <= %%%%fls.%s)) ? 1 : (((%%%%fdata.%s > %%%%fls.%s) && (%%%%fdata.%s < %%%%fus.%s)) ? 0 : (((%%%%fdata.%s >= %%%%fus.%s) && (%%%%fdata.%s < %%%%fuf.%s)) ? 1 : ((%%%%fdata.%s > %%%%fuf.%s) ? 2 : -1 ))))) \"\n",S,S,S,S,S,S,S,S,S,S,S,S,S,S,S,S,S,S)
	des_ctx		= sprintf("destroy tag name=ctx.%s \n", STEP_NO[i] )

	ack_state	= sprintf("create tag name=ack_data.%s \n", STEP_NO[i] )
	des_ack_state	= sprintf("destroy tag name=ack_data.%s \n", STEP_NO[i] )

	context		= sprintf("create tag name=context.%s \"com=(ctx.%s==2)?\\\"ctxBkgdOutOfFlyer\\\":((ctx.%s==1)?\\\"ctxBkgdOutOfSpec\\\":((ctx.%s==0)?\\\"ctxBkgdWithinSpec\\\":\\\"ctxWindowPrim\\\" ))\"\n",S,S,S,S )
	des_context	= sprintf("destroy tag name=context.%s \n", STEP_NO[i] )
	sub_context	= sprintf("sub tag name=context.%s mbx=WINsrv \"outmap=mod box winCharMach boxValue cx=%%%%s\" \n", STEP_NO[i] )

#	chng_mode	= sprintf("create tag name=chng_mode.%s \"com=((ctx.%s == 1) || (ctx.%s == 2)) ? \\\"winMenu mnuDataAck itmManual\\\" : \\\" \\\" \" \n", STEP_NO[i], STEP_NO[i], STEP_NO[i] )
#	des_chng_mode	= sprintf("destroy tag name=chng_mode.%s \n", STEP_NO[i] )
	sub_chng_mode	= sprintf("sub tag name=ctx.%s +change mbx=ReplyFilteredData \"outmap=%%%%s\" \"com=((ctx.%s == 1) || (ctx.%s == 2)) ? \\\"StopAuto\\\" : \\\"DontStop\\\" \"  \n", STEP_NO[i], STEP_NO[i], STEP_NO[i] )

	printf(desc, "\n")		>> 	tags_on
	printf(nom_val, "\n")		>> 	tags_on
	printf(nom_units, "\n")		>> 	tags_on
	printf(target, "\n")		>> 	tags_on
	printf(upper_spec, "\n")	>> 	tags_on
	printf(lower_spec, "\n")	>> 	tags_on
	printf(upper_flyer, "\n")	>> 	tags_on
	printf(lower_flyer, "\n")	>> 	tags_on
	printf(raw_data, "\n")		>> 	tags_on
	printf(post_data, "\n")		>> 	tags_on
	printf(data, "\n")		>> 	tags_on
	printf(new_data, "\n")		>> 	tags_on
	printf(init, "\n")		>> 	tags_on
	printf(sub_data_nom, "\n")	>> 	tags_on
	printf(sub_data_char, "\n")	>> 	tags_on
	printf(sub_data_val, "\n")	>> 	tags_on
	printf(sub_data_indv_b, "\n")	>> 	tags_on
	printf(sub_data_indv_f, "\n")	>> 	tags_on
	printf(sub_raw_new, "\n")	>> 	tags_on
	printf(ctx, "\n")		>>	tags_on
	printf(context, "\n")		>> 	tags_on
	printf(sub_context, "\n")	>> 	tags_on
#	printf(chng_mode, "\n")		>> 	tags_on
	printf(sub_chng_mode, "\n")	>> 	tags_on
	printf(ack_state, "\n")		>> 	tags_on
	printf(sub_data_indv_x, "\n")	>> 	tags_on
	printf("\n")			>> 	tags_on

	printf(des_ack_state, "\n")	>> 	tags_off
	printf(des_chng_mode, "\n")	>> 	tags_off
	printf(des_context, "\n")	>> 	tags_off
	printf(des_ctx, "\n")		>>	tags_off
	printf(des_init, "\n")		>> 	tags_off
	printf(des_new_data, "\n")	>> 	tags_off
	printf(des_data, "\n")		>> 	tags_off
	printf(des_post_data, "\n")	>> 	tags_off
	printf(des_raw_data, "\n")	>> 	tags_off
	printf(des_desc, "\n")		>> 	tags_off
	printf(des_nom_val, "\n")	>> 	tags_off
	printf(des_nom_units, "\n")	>> 	tags_off
	printf(des_target, "\n")	>> 	tags_off
	printf(des_upper_spec, "\n")	>> 	tags_off
	printf(des_lower_spec, "\n")	>> 	tags_off
	printf(des_upper_flyer, "\n")	>> 	tags_off
	printf(des_lower_flyer, "\n")	>> 	tags_off
	printf("\n")			>> 	tags_off

# 	End While i=1 to number of line in character file.
	}
# END BEGIN

printf("END OF BEGIN PROCESSING \n\n")
}
# START MAIN

{
printf("START OF MAIN PROCESSING \n\n")
	if( NR == 1) {
		BatchSize = 3 * BatchSize
		print("Batch size: " BatchSize "\n")
	        printf("\n")                    >>      tags_off
	}

	print("Start of Main...\n")
	for( i = 1; i <= CNT; ++i )
	{
		print("i = " i "\n")
		data_cnt	=	sprintf("create tag name=data_cnt.%s.%s \n", STEP_NO[i], $1 )
		data_cnt	=	sprintf("create tag name=data_cnt.%s.%s value=%s \n", STEP_NO[i], $1, DrawBatchSize )
		des_data_cnt	=	sprintf("destroy tag name=data_cnt.%s.%s \n", STEP_NO[i], $1 )

		start_batch	=	sprintf("create tag name=start_batch.%s.%s \"com=(data_cnt.%s.%s - %s + 1 ) \" \n",STEP_NO[i], $1, STEP_NO[i], $1, DrawBatchSize )
		des_start_batch	=	sprintf("destroy tag name=start_batch.%s.%s \n", STEP_NO[i], $1 )

		subscribe	=	sprintf("sub tag name=start_batch.%s.%s mbx=SPCsrv \"outmap=graph %s.%s.*Run batch=%s startbatch=%%%%s\" \n", STEP_NO[i], $1, STEP_NO[i], $1, BatchSize )
		des_subscribe	=	sprintf("unsub tag name=start_batch.%s.%s mbx=SPCsrv \n", STEP_NO[i], $1 )

 
		printf(data_cnt, "\n")		>> 	tags_on
		printf(start_batch, "\n")	>> 	tags_on
		printf(subscribe, "\n")		>> 	subs_on
		printf("\n")			>> 	tags_on
 
		printf(des_start_batch, "\n")	>> 	tags_off
		printf(des_data_cnt, "\n")	>> 	tags_off
		printf(des_subscribe, "\n")	>> 	subs_off
		printf("\n")			>> 	tags_off
	}
printf("END OF MAIN PROCESSING \n")
}
